'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFINE_MACRO = undefined;

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _Macro = require('./Macro');

var _Macro2 = _interopRequireDefault(_Macro);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var DEFINE_MACRO = exports.DEFINE_MACRO = function defineMacro(path, scope) {
  "use strict";

  var node = path.node;

  var location = (0, _utils.getLocationMessage)(node);
  if (!t.isIdentifier(node.arguments[0])) {
    throw new Error('First argument to DEFINE_MACRO must be an identifier' + location);
  }
  if (!t.isFunction(node.arguments[1])) {
    throw new Error('Second argument to DEFINE_MACRO must be a FunctionExpression or ArrowFunctionExpression' + location);
  }
  _Macro2.default.register(node.arguments[0].name, path.get('arguments.1'), scope, location);
  path.remove();
};